import type { Token } from "../token";
import { Bridge } from "../bridge/bridge";
import { BigNumber } from "@ethersproject/bignumber";
import { ContractTransaction } from "@ethersproject/contracts";
declare function useApproveBridgeSwap(ethereum: any, chainId: number): ((args: {
    token: Token;
    amount?: BigNumber;
}) => Promise<ContractTransaction>)[];
declare function useExecuteBridgeSwap(ethereum: any, chainId: number): ((args: {
    tokenFrom: Token;
    tokenTo: Token;
    amountFrom: BigNumber;
    amountTo: BigNumber;
    chainIdTo: number;
    addressTo?: string;
}) => Promise<ContractTransaction>)[];
declare function useCalculateBridgeSwapOutput(ethereum: any, chainId: number): ((args: {
    tokenFrom: Token;
    tokenTo: Token;
    amountFrom: BigNumber;
    chainIdTo: number;
}) => Promise<Bridge.BridgeOutputEstimate>)[];
export { useApproveBridgeSwap, useExecuteBridgeSwap, useCalculateBridgeSwapOutput };
