import type { Token } from "../token";
import { SwapPools } from "../swappools";
import { BigNumber } from "@ethersproject/bignumber";
import { ContractTransaction } from "@ethersproject/contracts";
export declare function useChainStableswapLPToken(ethereum: any, chainId: number): SwapPools.SwapPoolToken[];
export declare function useChainETHSwapLPToken(ethereum: any, chainId: number): SwapPools.SwapPoolToken[];
export declare function useHarmonyJewelLPToken(ethereum: any, chainId: number): SwapPools.SwapToken[];
export declare function useHarmonyAVAXLPToken(ethereum: any, chainId: number): SwapPools.SwapToken[];
export declare function useCalculateAddLiquidity(ethereum: any, chainId: number): ((args: {
    lpToken: SwapPools.SwapPoolToken;
    amounts: BigNumber[];
}) => Promise<BigNumber>)[];
export declare function useCalculateRemoveLiquidity(ethereum: any, chainId: number): ((args: {
    lpToken: SwapPools.SwapPoolToken;
    amount: BigNumber;
}) => Promise<BigNumber[]>)[];
export declare function useCalculateRemoveLiquidityOneToken(ethereum: any, chainId: number): ((args: {
    lpToken: SwapPools.SwapPoolToken;
    token: Token;
    amount: BigNumber;
}) => Promise<BigNumber[]>)[];
export declare function useAddLiquidity(ethereum: any, chainId: number): ((args: {
    lpToken: SwapPools.SwapPoolToken;
    deadline: BigNumber;
    amounts: BigNumber[];
    minToMint: BigNumber;
}) => Promise<ContractTransaction>)[];
export declare function useRemoveLiquidity(ethereum: any, chainId: number): ((args: {
    lpToken: SwapPools.SwapPoolToken;
    deadline: BigNumber;
    amount: BigNumber;
    minAmounts: BigNumber[];
}) => Promise<ContractTransaction>)[];
export declare function useRemoveLiquidityOneToken(ethereum: any, chainId: number): ((args: {
    lpToken: SwapPools.SwapPoolToken;
    deadline: BigNumber;
    amount: BigNumber;
    minAmount: BigNumber;
    token: Token;
}) => Promise<ContractTransaction>)[];
export declare function useCalculateSwapRate(ethereum: any, chainId: number): ((args: {
    tokenFrom: Token;
    tokenTo: Token;
    amountIn: BigNumber;
}) => Promise<BigNumber>)[];
export declare function useApproveLPToken(ethereum: any, chainId: number): ((args: {
    lpToken: SwapPools.SwapPoolToken;
    amount?: BigNumber;
}) => Promise<ContractTransaction>)[];
