var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Tokens } from "../tokens.js";
import { SwapPools } from "../swappools.js";
import { TokenSwap } from "../tokenswap.js";
import { useSignerFromEthereumFn } from "./signer.js";
import { useEffect, useState } from "react";
export function useChainStableswapLPToken(ethereum, chainId) {
    var _a = useState(null), lpToken = _a[0], setLpToken = _a[1];
    useEffect(function () {
        if (typeof chainId !== 'undefined' && chainId !== null) {
            if (lpToken !== null) {
                if (lpToken.chainId !== chainId) {
                    setLpToken(SwapPools.stableswapPoolForNetwork(chainId));
                }
            }
            else {
                setLpToken(SwapPools.stableswapPoolForNetwork(chainId));
            }
        }
    }, [chainId]);
    return [lpToken];
}
export function useChainETHSwapLPToken(ethereum, chainId) {
    var _a = useState(null), lpToken = _a[0], setLpToken = _a[1];
    useEffect(function () {
        if (typeof chainId !== 'undefined' && chainId !== null) {
            if (lpToken !== null) {
                if (lpToken.chainId !== chainId) {
                    setLpToken(SwapPools.ethSwapPoolForNetwork(chainId));
                }
            }
            else {
                setLpToken(SwapPools.ethSwapPoolForNetwork(chainId));
            }
        }
    }, [chainId]);
    return [lpToken];
}
export function useHarmonyJewelLPToken(ethereum, chainId) {
    return [SwapPools.HARMONY_JEWEL_SWAP_TOKEN];
}
export function useHarmonyAVAXLPToken(ethereum, chainId) {
    return [SwapPools.HARMONY_AVAX_SWAP_TOKEN];
}
export function useCalculateAddLiquidity(ethereum, chainId) {
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, TokenSwap.calculateAddLiquidity(__assign(__assign({}, args), { chainId: chainId }))];
            });
        });
    }
    return [fn];
}
export function useCalculateRemoveLiquidity(ethereum, chainId) {
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, TokenSwap.calculateRemoveLiquidity(__assign(__assign({}, args), { chainId: chainId }))];
            });
        });
    }
    return [fn];
}
export function useCalculateRemoveLiquidityOneToken(ethereum, chainId) {
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, TokenSwap.calculateRemoveLiquidity(__assign(__assign({}, args), { chainId: chainId }))];
            });
        });
    }
    return [fn];
}
export function useAddLiquidity(ethereum, chainId) {
    var getSigner = useSignerFromEthereumFn()[0];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, TokenSwap.addLiquidity(__assign(__assign({}, args), { chainId: chainId, signer: getSigner(ethereum) }))];
            });
        });
    }
    return [fn];
}
export function useRemoveLiquidity(ethereum, chainId) {
    var getSigner = useSignerFromEthereumFn()[0];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, TokenSwap.removeLiquidity(__assign(__assign({}, args), { chainId: chainId, signer: getSigner(ethereum) }))];
            });
        });
    }
    return [fn];
}
export function useRemoveLiquidityOneToken(ethereum, chainId) {
    var getSigner = useSignerFromEthereumFn()[0];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, TokenSwap.removeLiquidityOneToken(__assign(__assign({}, args), { chainId: chainId, signer: getSigner(ethereum) }))];
            });
        });
    }
    return [fn];
}
export function useCalculateSwapRate(ethereum, chainId) {
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, TokenSwap.calculateSwapRate(__assign(__assign({}, args), { chainId: chainId }))
                        .then(function (res) { return res.amountOut; })];
            });
        });
    }
    return [fn];
}
export function useApproveLPToken(ethereum, chainId) {
    var getSigner = useSignerFromEthereumFn()[0];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, spender, token;
            return __generator(this, function (_b) {
                _a = args.lpToken, spender = _a.swapAddress, token = _a.baseToken;
                return [2 /*return*/, Tokens.approveTokenSpend(__assign(__assign({}, args), { spender: spender, token: token, chainId: chainId, signer: getSigner(ethereum) }))];
            });
        });
    }
    return [fn];
}
